use strict;
use warnings;

sub blockrename 
{
	&plog(3, "sub blockrename");

	my @tmp = ();		# read dir contents
#       my @d_arr = &dir_filtered($main::dir);
#	my $dtext = join ("\n", @d_arr);
	my $lw = 40;	# list width
	my $lh = 20;	# list height

        my $top = $main::mw -> Toplevel();
        $top -> title
        (
        	"Block Rename"
        );
	my $balloon = $top->Balloon();
        our $txt = $top -> Scrolled
        (
#        	'ROText',
        	'Text',
                -scrollbars=>"osoe",
                -width=>$lw,
                -height=>$lh,
        	-font=>$main::dialog_font,
		-wrap=>'none',
        )
        -> grid
        (
        	-row => 2,
        	-column => 1,
        	-columnspan => 1
        );
        $txt->menu(undef);

#        $txt -> insert
#        (
#        	'end',
#        	"$dtext"
#        );

        our $txt_r = $top -> Scrolled
        (
        	'Text',
                -scrollbars=>"osoe",
                -width=>$lw,
                -height=>$lh,
        	-font=>$main::dialog_font,
		-wrap=>'none',
        )
        -> grid
        (
        	-row => 2,
        	-column => 2,
        	-columnspan => 2
        );
        $txt_r->menu(undef);

#        $txt_r -> insert
#        (
#        	'end',
#        	"$dtext"
#        );

	my $frm = $top -> Frame()
        -> grid
        (
        	-row => 4,
        	-column => 1,
        	-columnspan => 2,
        	-sticky=>"ne"
        );

        $frm -> Button
        (
        	-text=>"Cleanup",
        	-activebackground => 'white',
        	-command => sub 
        	{
        		&br_cleanup;
        	}
        )
        -> pack(-side => 'left');

        my $clear = $frm -> Button
        (
        	-text=>"Clear",
        	-activebackground => 'white',
        	-command => sub 
        	{
        		$main::txt_r->delete('0.0','end');
        	}
        )
        -> pack(-side => 'left');
	$balloon->attach
	(
		$clear,
		-msg => "Clears Text In Right hand text box"
	);

	my $preview = $frm -> Checkbutton
	(
		-text=>"Preview",
		-variable=>\$main::testmode,
		-activeforeground => "blue"
	)
        -> pack(-side => 'left');
	$balloon->attach
	(
		$preview,
		-msg => "Preview changes that will be made.\n\nNote: This option always re-enables after a run for safety."
	);

        $frm -> Button
        (
        	-text=>"STOP !",
        	-activebackground => 'red',
        	-command => sub
		{
			$main::STOP = 1;
		}
        )
        -> pack(-side => 'left');

        my $list = $frm -> Button
        (
        	-text=>"LIST",
        	-activebackground => 'orange',
        	-command => \&txt_reset
        )
        -> pack(-side => 'left');

	$balloon->attach
	(
		$list,
		-msg => "List Directory / Reset Text"
	);

	$frm -> Label
	(
		-text=>"  "
	)
	-> pack(-side => 'left');

        $frm -> Button
        (
        	-text=>"RUN",
        	-activebackground => 'green',
        	-command => sub 
        	{
			if($main::testmode == 0)
			{
				$main::BR_DONE = 1;
				&br();
				$main::testmode = 1;
			}
			else
			{
				&br_preview();
			}
        	}
        )
        -> pack(-side => 'left');

	$frm -> Label
	(
		-text=>"  "
	)
	-> pack(-side => 'left');

	$frm -> Label
	(
		-text=>"  "
	)
	-> pack(-side => 'left');

        $frm -> Button
        (
        	-text=>"Close",
        	-activebackground => 'white',
        	-command => sub 
        	{
			if($main::BR_DONE)
			{
				$main::BR_DONE = 0;
        			&ls_dir;
			}
        		destroy $top;
        	}
        )
        -> pack(-side => 'left');

	$top->resizable(0,0);
	&txt_reset;
}

sub br_cleanup
{
	&plog(3, "sub br_cleanup");
	&prep_globals;
	my @flist = ();
	my @list = ();
	my $c = 0;
	my $file = "";

	@flist = split(/\n/, $main::txt -> get('1.0', 'end'));
	@list = split(/\n/, $main::txt_r -> get('1.0', 'end'));

	&br_txt_r_clear;
	for my $i(@list)
	{
		$file = $flist[$c];
		&plog(4, "sub br_cleanup: processing \"$file\" -> \"$i\"");
		$i = &br_ed2k_cleanup($i);		# strip ed2k link info
		$i = run_fixname_subs($file, $i);	# apply fixname routines ($file is needed, else some funcs mangle extensions)
		$c++;
	}

	my $dtext = join ("\n", @list);
        $main::txt_r-> insert
        (
        	'end',
        	"$dtext"
        );
}

sub br_txt_r_clear
{
	&plog(3, "sub br_txt_r_clear");
	$main::txt_r->delete('0.0','end');
}

sub txt_reset
{
	&plog(3, "sub txt_reset");
        my $dtext = join ("\n", &br_readdir($main::dir));
        &plog(4, "sub txt_reset: dtext: $dtext");

	$main::txt->delete('0.0','end');
	$main::txt_r->delete('0.0','end');

        $main::txt-> insert
        (
        	'end',
        	"$dtext"
        );
        $main::txt_r-> insert
        (
        	'end',
        	"$dtext"
        );
}

sub br
{
	&plog(3, "sub br:");
	
	if($main::LISTING)
	{
		&plog(0, "sub br: error, a listing is currently being preformed - aborting rename");
		return 0;
	}
	elsif($main::RUN)
	{
		&plog(0, "sub br: error, a rename is currently being preformed - aborting rename");
		return 0;
	}
	
	$main::STOP 	= 0;
	$main::RUN 	= 1;

	my $result_text	= "";
	my @new_l 	= split(/\n/, $main::txt_r -> get('1.0', 'end'));
	my @old_l 	= split(/\n/, $main::txt -> get('1.0', 'end'));
	my @a 		= ();
	my @b 		= ();
	my $c 		= 0;
	my $of 		= "";	# old file
	my $nf 		= "";	# new file

	# clean arrarys of return chars
	# using chomp caused issues with filenames containing whitespaces at beginging or the end
	# such as "hello.mp3 " or " hello.mp3"
	for(@new_l)
	{
		s/\n|\r//g;
	}
	for(@old_l)
	{
		s/\n|\r//g;
	}

	&clear_undo;
	&prep_globals;

	&plog(4, "sub br: checking that files to be renamed exist");
	for $of(@old_l)
	{
		&plog(4, "sub br: checking \"$of\"");
		if(!-f $of)
		{
			&plog(0, "sub br: ERROR: old file \"$of\" does not exist");
			$main::RUN = 1;
			return 0;
		}
	}

	if($#old_l < $#new_l || $#old_l > $#new_l)
	{
		&plog(0, "sub br: ERROR: length of new and old list does not match");	# prevent possible user cockup
		$main::RUN = 0;
		return 0;
	}

	while($c <= $#old_l)	# check for changes - then rename
	{
		if($main::STOP == 1)
		{
			$main::RUN = 0;
			return 0;
		}

		$of = $old_l[$c];
		$nf = $new_l[$c];
		$c++;

		&plog(4, "sub br: processing \"$of\" -> \"$nf\"");

		if(!$nf) # finish when we hit a blank line, else we risk zero'ing the rest of the filenames
		{
			&plog(4, "sub br: no new filename for \"$of\" provided, assuming end of renaming");
			last;
		}

		
		$nf = &br_ed2k_cleanup($nf);		
		&plog(4, "sub br: renaming \"$of\" -> \"$nf\"");

		if($of eq $nf)
		{
			next;
		}

		if(&fn_rename ($of, $nf))
		{
			push @main::undo_pre, $main::cwd."/".$of;
			push @main::undo_cur, $main::cwd."/".$nf;
			push @a, $of;
			push @b, $nf;
			$result_text .= "\"$of\" -> \"$nf\"\n";
			&plog(4, "sub br: renamed");
		}
		else
		{
			&plog(0, "sub br: rename failed !");
		}
	}
	&br_show_lists("Block Rename Results", \@a, \@b);
	&txt_reset;

	$main::RUN = 0;
	return 1;
}


sub br_ed2k_cleanup
{
	my $link = shift;
	&plog(3, "sub br_ed2k_cleanup: \"$link\"");
		if($link =~ m/^ed2k:\/\/\|file\|(.*?)\|/i)
		{
			&plog(4, "sub br_ed2k_cleanup: \"$link\" -> \"$1\"");
			$link = $1;
		}
	return $link;
}

sub br_readdir 
{
	my $d = shift;
        my @dl_1 = ();
        my @dl_2 = ();

	&plog(3, "sub br_readdir: \"$d\"");

	opendir(DIR, "$d") or &plog(0, "sub br_readdir: cant open directory $d, $!");
	@dl_1 = CORE::readdir(DIR);
       	closedir DIR;

        for(@dl_1) 
        {
        	s/^\s+|\s+$//g;
        	if($_ eq "." || $_ eq ".." || $_ eq "") 
        	{
                	next;
                }

                if(!$main::proc_dirs && -d $_) 
                {
                	next;
                }

                if(!$main::ig_type == 0 && $_ !~ /\.($main::file_ext_2_proc)$/i)
                {
                	next;
                }
                push @dl_2, $_;
        }

        return &ci_sort(@dl_2);
}


1;

