use strict;
use warnings;

#--------------------------------------------------------------------------------------------------------------
# Run Namefix
#--------------------------------------------------------------------------------------------------------------

sub prep_globals 
{
	# reset misc vars
	$main::STOP		= 0;
	$main::id3_change	= 0;
        $main::change 		= 0;
        $main::suggestF 	= 0;
        $main::tmpfilefound 	= 0;
        $main::enum_count 	= 0;
        $main::tags_rm		= 0;
        $main::last_recr_dir 	= "";

        my $t_s 		= "";	# tmp string
        my @tmp_arr		= "";

        # prep vars we need
        if($main::disable_regexp == 1) 
        {
        	$main::rpwold_escaped = &escape_string($main::rpwold);
        } else 
        {
        	$main::rpwold_escaped = $main::rpwold;
        }

        if($main::filter_use_re == 0) 
        {
        	$main::filter_string_escaped = &escape_string($main::filter_string);
        }
        else 
        {
        	$main::filter_string_escaped = $main::filter_string;
        }

	# get killwords array & escape
	@main::kill_words_arr = @main::kill_words_arr_backup;	# restore array from backup (allows us to escape builtin list without escaping multiple times)

        if(-f $main::killwords_file)
        {
                @tmp_arr = &readsf("$main::killwords_file");
        }
	@tmp_arr = @main::kill_words_arr;

	@main::kill_words_arr = ();
	for $t_s(@tmp_arr) 
	{
		$t_s = &escape_string($t_s);
		push (@main::kill_words_arr, $t_s);
	}

	# get kill pattern array

        if(-f $main::killpat_file) 
        {
                @main::kill_patterns_arr = &readsf("$main::killpat_file");
        }
        if(-f $main::casing_file) 
        {
        	undef @main::word_casing_arr;

                @tmp_arr = &readf("$main::casing_file");
                for $t_s(@tmp_arr) 
                {
                	$t_s = escape_string($t_s);
                	push (@main::word_casing_arr, $t_s);
                }
        }
}

sub run_namefix
{
	&plog(3, "sub run_namefix:");
	
	if($main::LISTING)
	{
		&plog(0, "sub run_namefix: error, a listing is currently being preformed - aborting rename");
		return 0;
	}
	elsif($main::RUN)
	{
		&plog(0, "sub run_namefix: error, a rename is currently being preformed - aborting rename");
		return 0;
	}
	
	$main::RUN		= 1;
	$main::orig_dir 	= cwd;

        my $t_s 		= "";	# tmp string
        my @tmp_arr		= "";     

        chdir $main::dir;
	&clear_undo;
	&prep_globals;
	&hlist_clear;
	
	&nf_print("..");
        if(!$main::recr) 
        {
		my @dirlist = &dir_filtered($main::dir);

                foreach(@dirlist) 
                {
                        if(!$_) # stop warnings getting spat out
                        {
                                next;
                        }
                        if($main::proc_dirs) 
                        {
                                &fixname($_);
                                next;
                        }
                        elsif(! -d $_) 
                        {
                                &fixname($_);
                        }
                }
        }
        if($main::recr) 
        {
                #find(\&fixname, "$main::dir");
		@main::find_arr = ();
		find(\&find_fix, "$main::dir");
		print @main::find_arr;
		for(@main::find_arr)
		{
			&fixname($_);
		}
		@main::find_arr = ();
        }

	# print info

        $t_s = "have";
        if ($main::testmode == 1) 
        {
        	$t_s = "would have";
        }
        &nf_print(" ");
	&nf_print("$main::change files $t_s been modified");

	if($main::id3_mode) 
	{
		&nf_print("$main::id3_change mp3s tags $t_s been updated.");
	}
        if($main::tags_rm) 
        {
        	&nf_print("$main::tags_rm mp3 tags $t_s been removed");
        }
        &nf_print(" ");


        if($main::suggestF != 0) 
        {
	        &nf_print("namefix.pl was unable to rename $main::suggestF files.\nPerhaps you should enable \"FS Fix\".");
		&nf_print(" ");
        }

        if($main::tmpfilefound != 0) 
        {
		&plog(0, "namefix.pl found tmp some of its own tmp files, this should not happen. Please check the following list of files.\n$main::tmpfilelist\n");
	}

	&nf_print("namefix.pl $main::version by $main::author");

        # cleanup

	$main::testmode = 1;	# return to test mode for safety :)
	$main::RUN = 0;		# finished renaming - turn off run flag
	chdir $main::dir;	# return to users working dir
}

sub find_fix
{
	# perls file find will not pass a var to a sub - instead your stuck with $_
	# Im not a fan off this, I like to use my own vars in subs and not mess with perls globals
	# so here is my simple work around to keep the fixname sub neat and tidy.

	push @main::find_arr, $_;
	return;
}

1;